["^ ","~:resource-id",["~:shadow.build.classpath/resource","com/cognitect/transit/handlers.js"],"~:js","goog.provide(\"com.cognitect.transit.handlers\");\ngoog.require(\"com.cognitect.transit.util\");\ngoog.require(\"com.cognitect.transit.types\");\ngoog.require(\"goog.math.Long\");\ngoog.scope(function() {\n  var handlers = com.cognitect.transit.handlers, util = com.cognitect.transit.util, types = com.cognitect.transit.types, Long = goog.math.Long;\n  handlers.ctorGuid = 0;\n  handlers.ctorGuidProperty = \"transit$guid$\" + util.randomUUID();\n  handlers.typeTag = function(ctor) {\n    if (ctor == null) {\n      return \"null\";\n    } else if (ctor === String) {\n      return \"string\";\n    } else if (ctor === Boolean) {\n      return \"boolean\";\n    } else if (ctor === Number) {\n      return \"number\";\n    } else if (ctor === Array) {\n      return \"array\";\n    } else if (ctor === Object) {\n      return \"map\";\n    } else {\n      var tag = ctor[handlers.ctorGuidProperty];\n      if (tag == null) {\n        if (typeof Object.defineProperty != \"undefined\") {\n          tag = ++handlers.ctorGuid;\n          Object.defineProperty(ctor, handlers.ctorGuidProperty, {value:tag, enumerable:false});\n        } else {\n          ctor[handlers.ctorGuidProperty] = tag = ++handlers.ctorGuid;\n        }\n      }\n      return tag;\n    }\n  };\n  handlers.constructor = function(x) {\n    if (x == null) {\n      return null;\n    } else {\n      return x.constructor;\n    }\n  };\n  handlers.padZeros = function(n, m) {\n    var s = n.toString();\n    for (var i = s.length; i < m; i++) {\n      s = \"0\" + s;\n    }\n    return s;\n  };\n  handlers.stringableKeys = function(m) {\n    var stringable = false, ks = util.objectKeys(m);\n    for (var i = 0; i < ks.length; i++) {\n    }\n    return true;\n  };\n  handlers.NilHandler = function Transit$NilHandler() {\n  };\n  handlers.NilHandler.prototype.tag = function(v) {\n    return \"_\";\n  };\n  handlers.NilHandler.prototype.rep = function(v) {\n    return null;\n  };\n  handlers.NilHandler.prototype.stringRep = function(v) {\n    return \"null\";\n  };\n  handlers.StringHandler = function Transit$StringHandler() {\n  };\n  handlers.StringHandler.prototype.tag = function(v) {\n    return \"s\";\n  };\n  handlers.StringHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.StringHandler.prototype.stringRep = function(v) {\n    return v;\n  };\n  handlers.NumberHandler = function Transit$NumberHandler() {\n  };\n  handlers.NumberHandler.prototype.tag = function(v) {\n    return \"i\";\n  };\n  handlers.NumberHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.NumberHandler.prototype.stringRep = function(v) {\n    return v.toString();\n  };\n  handlers.IntegerHandler = function Transit$IntegerHandler() {\n  };\n  handlers.IntegerHandler.prototype.tag = function(v) {\n    return \"i\";\n  };\n  handlers.IntegerHandler.prototype.rep = function(v) {\n    return v.toString();\n  };\n  handlers.IntegerHandler.prototype.stringRep = function(v) {\n    return v.toString();\n  };\n  handlers.BooleanHandler = function Transit$BooleanHandler() {\n  };\n  handlers.BooleanHandler.prototype.tag = function(v) {\n    return \"?\";\n  };\n  handlers.BooleanHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.BooleanHandler.prototype.stringRep = function(v) {\n    return v.toString();\n  };\n  handlers.ArrayHandler = function Transit$ArrayHandler() {\n  };\n  handlers.ArrayHandler.prototype.tag = function(v) {\n    return \"array\";\n  };\n  handlers.ArrayHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.ArrayHandler.prototype.stringRep = function(v) {\n    return null;\n  };\n  handlers.MapHandler = function Transit$MapHandler() {\n  };\n  handlers.MapHandler.prototype.tag = function(v) {\n    return \"map\";\n  };\n  handlers.MapHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.MapHandler.prototype.stringRep = function(v) {\n    return null;\n  };\n  handlers.VerboseDateHandler = function Transit$VerboseDateHandler() {\n  };\n  handlers.VerboseDateHandler.prototype.tag = function(v) {\n    return \"t\";\n  };\n  handlers.VerboseDateHandler.prototype.rep = function(v) {\n    return v.getUTCFullYear() + \"-\" + handlers.padZeros(v.getUTCMonth() + 1, 2) + \"-\" + handlers.padZeros(v.getUTCDate(), 2) + \"T\" + handlers.padZeros(v.getUTCHours(), 2) + \":\" + handlers.padZeros(v.getUTCMinutes(), 2) + \":\" + handlers.padZeros(v.getUTCSeconds(), 2) + \".\" + handlers.padZeros(v.getUTCMilliseconds(), 3) + \"Z\";\n  };\n  handlers.VerboseDateHandler.prototype.stringRep = function(v, h) {\n    return h.rep(v);\n  };\n  handlers.DateHandler = function Transit$DateHandler() {\n  };\n  handlers.DateHandler.prototype.tag = function(v) {\n    return \"m\";\n  };\n  handlers.DateHandler.prototype.rep = function(v) {\n    return v.valueOf();\n  };\n  handlers.DateHandler.prototype.stringRep = function(v) {\n    return v.valueOf().toString();\n  };\n  handlers.DateHandler.prototype.getVerboseHandler = function(v) {\n    return new handlers.VerboseDateHandler();\n  };\n  handlers.UUIDHandler = function Transit$UUIDHandler() {\n  };\n  handlers.UUIDHandler.prototype.tag = function(v) {\n    return \"u\";\n  };\n  handlers.UUIDHandler.prototype.rep = function(v) {\n    return v.toString();\n  };\n  handlers.UUIDHandler.prototype.stringRep = function(v) {\n    return v.toString();\n  };\n  handlers.KeywordHandler = function Transit$KeywordHandler() {\n  };\n  handlers.KeywordHandler.prototype.tag = function(v) {\n    return \":\";\n  };\n  handlers.KeywordHandler.prototype.rep = function(v) {\n    return v._name;\n  };\n  handlers.KeywordHandler.prototype.stringRep = function(v, h) {\n    return h.rep(v);\n  };\n  handlers.SymbolHandler = function Transit$SymbolHandler() {\n  };\n  handlers.SymbolHandler.prototype.tag = function(v) {\n    return \"$\";\n  };\n  handlers.SymbolHandler.prototype.rep = function(v) {\n    return v._name;\n  };\n  handlers.SymbolHandler.prototype.stringRep = function(v, h) {\n    return h.rep(v);\n  };\n  handlers.TaggedHandler = function Transit$TaggedHandler() {\n  };\n  handlers.TaggedHandler.prototype.tag = function(v) {\n    return v.tag;\n  };\n  handlers.TaggedHandler.prototype.rep = function(v) {\n    return v.rep;\n  };\n  handlers.TaggedHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.TransitSetHandler = function Transit$TransitSetHandler() {\n  };\n  handlers.TransitSetHandler.prototype.tag = function(v) {\n    return \"set\";\n  };\n  handlers.TransitSetHandler.prototype.rep = function(v) {\n    var arr = [];\n    v.forEach(function(key, set) {\n      arr.push(key);\n    });\n    return types.taggedValue(\"array\", arr);\n  };\n  handlers.TransitSetHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.TransitArrayMapHandler = function Transit$ArrayMapHandler() {\n  };\n  handlers.TransitArrayMapHandler.prototype.tag = function(v) {\n    return \"map\";\n  };\n  handlers.TransitArrayMapHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.TransitArrayMapHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.TransitMapHandler = function Transit$MapHandler() {\n  };\n  handlers.TransitMapHandler.prototype.tag = function(v) {\n    return \"map\";\n  };\n  handlers.TransitMapHandler.prototype.rep = function(v) {\n    return v;\n  };\n  handlers.TransitMapHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.BufferHandler = function Transit$BufferHandler() {\n  };\n  handlers.BufferHandler.prototype.tag = function(v) {\n    return \"b\";\n  };\n  handlers.BufferHandler.prototype.rep = function(v) {\n    return v.toString(\"base64\");\n  };\n  handlers.BufferHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.Uint8ArrayHandler = function Transit$Uint8ArrayHandler() {\n  };\n  handlers.Uint8ArrayHandler.prototype.tag = function(v) {\n    return \"b\";\n  };\n  handlers.Uint8ArrayHandler.prototype.rep = function(v) {\n    return util.Uint8ToBase64(v);\n  };\n  handlers.Uint8ArrayHandler.prototype.stringRep = function(v, h) {\n    return null;\n  };\n  handlers.defaultHandlers = function(hs) {\n    hs.set(null, new handlers.NilHandler());\n    hs.set(String, new handlers.StringHandler());\n    hs.set(Number, new handlers.NumberHandler());\n    hs.set(Long, new handlers.IntegerHandler());\n    hs.set(Boolean, new handlers.BooleanHandler());\n    hs.set(Array, new handlers.ArrayHandler());\n    hs.set(Object, new handlers.MapHandler());\n    hs.set(Date, new handlers.DateHandler());\n    hs.set(types.UUID, new handlers.UUIDHandler());\n    hs.set(types.Keyword, new handlers.KeywordHandler());\n    hs.set(types.Symbol, new handlers.SymbolHandler());\n    hs.set(types.TaggedValue, new handlers.TaggedHandler());\n    hs.set(types.TransitSet, new handlers.TransitSetHandler());\n    hs.set(types.TransitArrayMap, new handlers.TransitArrayMapHandler());\n    hs.set(types.TransitMap, new handlers.TransitMapHandler());\n    if (typeof goog.global.Buffer != \"undefined\") {\n      hs.set(goog.global.Buffer, new handlers.BufferHandler());\n    }\n    if (typeof Uint8Array != \"undefined\") {\n      hs.set(Uint8Array, new handlers.Uint8ArrayHandler());\n    }\n    return hs;\n  };\n  handlers.Handlers = function Transit$Handlers() {\n    this.handlers = {};\n    handlers.defaultHandlers(this);\n  };\n  handlers.Handlers.prototype.get = function(ctor) {\n    var h = null;\n    if (typeof ctor === \"string\") {\n      h = this.handlers[ctor];\n    } else {\n      h = this.handlers[handlers.typeTag(ctor)];\n    }\n    if (h != null) {\n      return h;\n    } else {\n      return this.handlers[\"default\"];\n    }\n  };\n  handlers.Handlers.prototype[\"get\"] = handlers.Handlers.prototype.get;\n  handlers.validTag = function(tag) {\n    switch(tag) {\n      case \"null\":\n      case \"string\":\n      case \"boolean\":\n      case \"number\":\n      case \"array\":\n      case \"map\":\n        return false;\n        break;\n    }\n    return true;\n  };\n  handlers.Handlers.prototype.set = function(ctor, handler) {\n    if (typeof ctor === \"string\" && handlers.validTag(ctor)) {\n      this.handlers[ctor] = handler;\n    } else {\n      this.handlers[handlers.typeTag(ctor)] = handler;\n    }\n  };\n});\n","~:source","// Copyright 2014 Cognitect. All Rights Reserved.\n//\n// Licensed under the Apache License, Version 2.0 (the \"License\");\n// you may not use this file except in compliance with the License.\n// You may obtain a copy of the License at\n//\n//      http://www.apache.org/licenses/LICENSE-2.0\n//\n// Unless required by applicable law or agreed to in writing, software\n// distributed under the License is distributed on an \"AS-IS\" BASIS,\n// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\n// See the License for the specific language governing permissions and\n// limitations under the License.\n\ngoog.provide(\"com.cognitect.transit.handlers\");\ngoog.require(\"com.cognitect.transit.util\");\ngoog.require(\"com.cognitect.transit.types\");\ngoog.require(\"goog.math.Long\");\n\ngoog.scope(function () {\n\n    var handlers = com.cognitect.transit.handlers,\n        util     = com.cognitect.transit.util,\n        types    = com.cognitect.transit.types,\n        Long     = goog.math.Long;\n\n    handlers.ctorGuid = 0;\n\n    /**\n     * @const\n     * @type {string}\n     */\n    handlers.ctorGuidProperty = \"transit$guid$\" + util.randomUUID();\n\n    handlers.typeTag = function (ctor) {\n        if (ctor == null) {\n            return \"null\";\n        } else if (ctor === String) {\n            return \"string\";\n        } else if (ctor === Boolean) {\n            return \"boolean\";\n        } else if (ctor === Number) {\n            return \"number\";\n        } else if (ctor === Array) {\n            return \"array\";\n        } else if (ctor === Object) {\n            return \"map\";\n        } else {\n            var tag = ctor[handlers.ctorGuidProperty];\n            if (tag == null) {\n                if (typeof Object.defineProperty != \"undefined\") {\n                    tag = ++handlers.ctorGuid;\n                    Object.defineProperty(ctor, handlers.ctorGuidProperty, {\n                        value: tag,\n                        enumerable: false\n                    });\n                } else {\n                    ctor[handlers.ctorGuidProperty] = tag = ++handlers.ctorGuid;\n                }\n            }\n            return tag;\n        }\n    };\n\n    handlers.constructor = function (x) {\n        if (x == null) {\n            return null;\n        } else {\n            return x.constructor;\n        }\n    };\n\n    handlers.padZeros = function (n, m) {\n        var s = n.toString();\n        for (var i = s.length; i < m; i++) {\n            s = \"0\" + s;\n        }\n        return s;\n    };\n\n    handlers.stringableKeys = function (m) {\n        var stringable = false,\n            ks = util.objectKeys(m);\n\n        for (var i = 0; i < ks.length; i++) {\n        }\n\n        return true;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.NilHandler = function Transit$NilHandler() {\n    };\n    handlers.NilHandler.prototype.tag = function (v) {\n        return \"_\";\n    };\n    handlers.NilHandler.prototype.rep = function (v) {\n        return null;\n    };\n    handlers.NilHandler.prototype.stringRep = function (v) {\n        return \"null\";\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.StringHandler = function Transit$StringHandler() {\n    };\n    handlers.StringHandler.prototype.tag = function (v) {\n        return \"s\";\n    };\n    handlers.StringHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.StringHandler.prototype.stringRep = function (v) {\n        return v;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.NumberHandler = function Transit$NumberHandler() {\n    };\n    handlers.NumberHandler.prototype.tag = function (v) {\n        return \"i\";\n    };\n    handlers.NumberHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.NumberHandler.prototype.stringRep = function (v) {\n        return v.toString();\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.IntegerHandler = function Transit$IntegerHandler() {\n    };\n    handlers.IntegerHandler.prototype.tag = function (v) {\n        return \"i\";\n    };\n    handlers.IntegerHandler.prototype.rep = function (v) {\n        return v.toString();\n    };\n    handlers.IntegerHandler.prototype.stringRep = function (v) {\n        return v.toString();\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.BooleanHandler = function Transit$BooleanHandler() {\n    };\n    handlers.BooleanHandler.prototype.tag = function (v) {\n        return \"?\";\n    };\n    handlers.BooleanHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.BooleanHandler.prototype.stringRep = function (v) {\n        return v.toString();\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.ArrayHandler = function Transit$ArrayHandler() {\n    };\n    handlers.ArrayHandler.prototype.tag = function (v) {\n        return \"array\";\n    };\n    handlers.ArrayHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.ArrayHandler.prototype.stringRep = function (v) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.MapHandler = function Transit$MapHandler() {\n    };\n    handlers.MapHandler.prototype.tag = function (v) {\n        return \"map\";\n    };\n    handlers.MapHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.MapHandler.prototype.stringRep = function (v) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.VerboseDateHandler = function Transit$VerboseDateHandler() {\n    };\n    handlers.VerboseDateHandler.prototype.tag = function (v) {\n        return \"t\";\n    };\n    handlers.VerboseDateHandler.prototype.rep = function (v) {\n        return v.getUTCFullYear() + \"-\" + handlers.padZeros(v.getUTCMonth() + 1, 2) + \"-\" +\n            handlers.padZeros(v.getUTCDate(), 2) + \"T\" + handlers.padZeros(v.getUTCHours(), 2) + \":\" +\n            handlers.padZeros(v.getUTCMinutes(), 2) + \":\" + handlers.padZeros(v.getUTCSeconds(), 2) + \".\" +\n            handlers.padZeros(v.getUTCMilliseconds(), 3) + \"Z\";\n    };\n    handlers.VerboseDateHandler.prototype.stringRep = function (v, h) {\n        return h.rep(v);\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.DateHandler = function Transit$DateHandler() {\n    };\n    handlers.DateHandler.prototype.tag = function (v) {\n        return \"m\";\n    };\n    handlers.DateHandler.prototype.rep = function (v) {\n        return v.valueOf();\n    };\n    handlers.DateHandler.prototype.stringRep = function (v) {\n        return v.valueOf().toString();\n    };\n    handlers.DateHandler.prototype.getVerboseHandler = function (v) {\n        return new handlers.VerboseDateHandler();\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.UUIDHandler = function Transit$UUIDHandler() {\n    };\n    handlers.UUIDHandler.prototype.tag = function (v) {\n        return \"u\";\n    };\n    handlers.UUIDHandler.prototype.rep = function (v) {\n        return v.toString();\n    };\n    handlers.UUIDHandler.prototype.stringRep = function (v) {\n        return v.toString();\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.KeywordHandler = function Transit$KeywordHandler() {\n    };\n    handlers.KeywordHandler.prototype.tag = function (v) {\n        return \":\";\n    };\n    handlers.KeywordHandler.prototype.rep = function (v) {\n        return v._name;\n    }; // NOTE: should be fqn\n    handlers.KeywordHandler.prototype.stringRep = function (v, h) {\n        return h.rep(v);\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.SymbolHandler = function Transit$SymbolHandler() {\n    };\n    handlers.SymbolHandler.prototype.tag = function (v) {\n        return \"$\";\n    };\n    handlers.SymbolHandler.prototype.rep = function (v) {\n        return v._name;\n    }; // NOTE: should be str\n    handlers.SymbolHandler.prototype.stringRep = function (v, h) {\n        return h.rep(v);\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.TaggedHandler = function Transit$TaggedHandler() {\n    };\n    handlers.TaggedHandler.prototype.tag = function (v) {\n        return v.tag;\n    };\n    handlers.TaggedHandler.prototype.rep = function (v) {\n        return v.rep;\n    };\n    handlers.TaggedHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.TransitSetHandler = function Transit$TransitSetHandler() {\n    };\n    handlers.TransitSetHandler.prototype.tag = function (v) {\n        return \"set\";\n    };\n    handlers.TransitSetHandler.prototype.rep = function (v) {\n        var arr = [];\n        v.forEach(function (key, set) {\n            arr.push(key);\n        });\n        return types.taggedValue(\"array\", arr);\n    };\n    handlers.TransitSetHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.TransitArrayMapHandler = function Transit$ArrayMapHandler() {\n    };\n    handlers.TransitArrayMapHandler.prototype.tag = function (v) {\n        return \"map\";\n    };\n    handlers.TransitArrayMapHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.TransitArrayMapHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.TransitMapHandler = function Transit$MapHandler() {\n    };\n    handlers.TransitMapHandler.prototype.tag = function (v) {\n        return \"map\";\n    };\n    handlers.TransitMapHandler.prototype.rep = function (v) {\n        return v;\n    };\n    handlers.TransitMapHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.BufferHandler = function Transit$BufferHandler() {\n    };\n    handlers.BufferHandler.prototype.tag = function (v) {\n        return \"b\";\n    };\n    handlers.BufferHandler.prototype.rep = function (v) {\n        return v.toString(\"base64\");\n    };\n    handlers.BufferHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.Uint8ArrayHandler = function Transit$Uint8ArrayHandler() {\n    };\n    handlers.Uint8ArrayHandler.prototype.tag = function (v) {\n        return \"b\";\n    };\n    handlers.Uint8ArrayHandler.prototype.rep = function (v) {\n        return util.Uint8ToBase64(v);\n    };\n    handlers.Uint8ArrayHandler.prototype.stringRep = function (v, h) {\n        return null;\n    };\n\n    handlers.defaultHandlers = function (hs) {\n        hs.set(null, new handlers.NilHandler());\n        hs.set(String, new handlers.StringHandler());\n        hs.set(Number, new handlers.NumberHandler());\n        hs.set(Long, new handlers.IntegerHandler());\n        hs.set(Boolean, new handlers.BooleanHandler());\n        hs.set(Array, new handlers.ArrayHandler());\n        hs.set(Object, new handlers.MapHandler());\n        hs.set(Date, new handlers.DateHandler());\n        hs.set(types.UUID, new handlers.UUIDHandler());\n        hs.set(types.Keyword, new handlers.KeywordHandler());\n        hs.set(types.Symbol, new handlers.SymbolHandler());\n        hs.set(types.TaggedValue, new handlers.TaggedHandler());\n        hs.set(types.TransitSet, new handlers.TransitSetHandler());\n        hs.set(types.TransitArrayMap, new handlers.TransitArrayMapHandler());\n        hs.set(types.TransitMap, new handlers.TransitMapHandler());\n\n        if (typeof goog.global.Buffer != \"undefined\") {\n            hs.set(goog.global.Buffer, new handlers.BufferHandler());\n        }\n\n        if (typeof Uint8Array != \"undefined\") {\n            hs.set(Uint8Array, new handlers.Uint8ArrayHandler());\n        }\n\n        return hs;\n    };\n\n    /**\n     * @constructor\n     */\n    handlers.Handlers = function Transit$Handlers() {\n        this.handlers = {};\n        handlers.defaultHandlers(this);\n    };\n\n    handlers.Handlers.prototype.get = function (ctor) {\n        var h = null;\n        if (typeof ctor === \"string\") {\n            h = this.handlers[ctor];\n        } else {\n            h = this.handlers[handlers.typeTag(ctor)];\n        }\n        if (h != null) {\n            return h;\n        } else {\n            return this.handlers[\"default\"];\n        }\n    };\n    handlers.Handlers.prototype[\"get\"] = handlers.Handlers.prototype.get;\n\n    handlers.validTag = function (tag) {\n        switch (tag) {\n            case \"null\":\n            case \"string\":\n            case \"boolean\":\n            case \"number\":\n            case \"array\":\n            case \"map\":\n                return false;\n                break;\n        }\n        return true;\n    };\n\n    handlers.Handlers.prototype.set = function (ctor, handler) {\n        if (typeof ctor === \"string\" && handlers.validTag(ctor)) {\n            this.handlers[ctor] = handler;\n        } else {\n            this.handlers[handlers.typeTag(ctor)] = handler;\n        }\n    };\n\n});    \n","~:compiled-at",1684858198118,"~:source-map-json","{\n\"version\":3,\n\"file\":\"com.cognitect.transit.handlers.js\",\n\"lineCount\":323,\n\"mappings\":\"AAcAA,IAAKC,CAAAA,OAAL,CAAa,gCAAb,CAAA;AACAD,IAAKE,CAAAA,OAAL,CAAa,4BAAb,CAAA;AACAF,IAAKE,CAAAA,OAAL,CAAa,6BAAb,CAAA;AACAF,IAAKE,CAAAA,OAAL,CAAa,gBAAb,CAAA;AAEAF,IAAKG,CAAAA,KAAL,CAAW,QAAS,EAAG;AAEnB,MAAIC,WAAWC,GAAIC,CAAAA,SAAUC,CAAAA,OAAQH,CAAAA,QAArC,EACII,OAAWH,GAAIC,CAAAA,SAAUC,CAAAA,OAAQC,CAAAA,IADrC,EAEIC,QAAWJ,GAAIC,CAAAA,SAAUC,CAAAA,OAAQE,CAAAA,KAFrC,EAGIC,OAAWV,IAAKW,CAAAA,IAAKD,CAAAA,IAHzB;AAKAN,UAASQ,CAAAA,QAAT,GAAoB,CAApB;AAMAR,UAASS,CAAAA,gBAAT,GAA4B,eAA5B,GAA8CL,IAAKM,CAAAA,UAAL,EAA9C;AAEAV,UAASW,CAAAA,OAAT,GAAmBC,QAAS,CAACC,IAAD,CAAO;AAC/B,QAAIA,IAAJ,IAAY,IAAZ;AACI,aAAO,MAAP;AADJ,UAEO,KAAIA,IAAJ,KAAaC,MAAb;AACH,aAAO,QAAP;AADG,UAEA,KAAID,IAAJ,KAAaE,OAAb;AACH,aAAO,SAAP;AADG,UAEA,KAAIF,IAAJ,KAAaG,MAAb;AACH,aAAO,QAAP;AADG,UAEA,KAAIH,IAAJ,KAAaI,KAAb;AACH,aAAO,OAAP;AADG,UAEA,KAAIJ,IAAJ,KAAaK,MAAb;AACH,aAAO,KAAP;AADG,UAEA;AACH,UAAIC,MAAMN,IAAA,CAAKb,QAASS,CAAAA,gBAAd,CAAV;AACA,UAAIU,GAAJ,IAAW,IAAX;AACI,YAAI,MAAOD,OAAOE,CAAAA,cAAlB,IAAoC,WAApC,CAAiD;AAC7CD,aAAA,GAAM,EAAEnB,QAASQ,CAAAA,QAAjB;AACAU,gBAAOE,CAAAA,cAAP,CAAsBP,IAAtB,EAA4Bb,QAASS,CAAAA,gBAArC,EAAuD,CACnDY,MAAOF,GAD4C,EAEnDG,WAAY,KAFuC,CAAvD,CAAA;AAF6C,SAAjD;AAOIT,cAAA,CAAKb,QAASS,CAAAA,gBAAd,CAAA,GAAkCU,GAAlC,GAAwC,EAAEnB,QAASQ,CAAAA,QAAnD;AAPJ;AADJ;AAWA,aAAOW,GAAP;AAbG;AAbwB,GAAnC;AA8BAnB,UAASuB,CAAAA,WAAT,GAAuBC,QAAS,CAACC,CAAD,CAAI;AAChC,QAAIA,CAAJ,IAAS,IAAT;AACI,aAAO,IAAP;AADJ;AAGI,aAAOA,CAAEF,CAAAA,WAAT;AAHJ;AADgC,GAApC;AAQAvB,UAAS0B,CAAAA,QAAT,GAAoBC,QAAS,CAACC,CAAD,EAAIC,CAAJ,CAAO;AAChC,QAAIC,IAAIF,CAAEG,CAAAA,QAAF,EAAR;AACA,SAAK,IAAIC,IAAIF,CAAEG,CAAAA,MAAf,EAAuBD,CAAvB,GAA2BH,CAA3B,EAA8BG,CAAA,EAA9B;AACIF,OAAA,GAAI,GAAJ,GAAUA,CAAV;AADJ;AAGA,WAAOA,CAAP;AALgC,GAApC;AAQA9B,UAASkC,CAAAA,cAAT,GAA0BC,QAAS,CAACN,CAAD,CAAI;AACnC,QAAIO,aAAa,KAAjB,EACIC,KAAKjC,IAAKkC,CAAAA,UAAL,CAAgBT,CAAhB,CADT;AAGA,SAAK,IAAIG,IAAI,CAAb,EAAgBA,CAAhB,GAAoBK,EAAGJ,CAAAA,MAAvB,EAA+BD,CAAA,EAA/B;;AAGA,WAAO,IAAP;AAPmC,GAAvC;AAaAhC,UAASuC,CAAAA,UAAT,GAAsBC,QAASC,mBAAkB,EAAG;GAApD;AAEAzC,UAASuC,CAAAA,UAAWG,CAAAA,SAAUvB,CAAAA,GAA9B,GAAoCwB,QAAS,CAACC,CAAD,CAAI;AAC7C,WAAO,GAAP;AAD6C,GAAjD;AAGA5C,UAASuC,CAAAA,UAAWG,CAAAA,SAAUG,CAAAA,GAA9B,GAAoCC,QAAS,CAACF,CAAD,CAAI;AAC7C,WAAO,IAAP;AAD6C,GAAjD;AAGA5C,UAASuC,CAAAA,UAAWG,CAAAA,SAAUK,CAAAA,SAA9B,GAA0CC,QAAS,CAACJ,CAAD,CAAI;AACnD,WAAO,MAAP;AADmD,GAAvD;AAOA5C,UAASiD,CAAAA,aAAT,GAAyBC,QAASC,sBAAqB,EAAG;GAA1D;AAEAnD,UAASiD,CAAAA,aAAcP,CAAAA,SAAUvB,CAAAA,GAAjC,GAAuCiC,QAAS,CAACR,CAAD,CAAI;AAChD,WAAO,GAAP;AADgD,GAApD;AAGA5C,UAASiD,CAAAA,aAAcP,CAAAA,SAAUG,CAAAA,GAAjC,GAAuCQ,QAAS,CAACT,CAAD,CAAI;AAChD,WAAOA,CAAP;AADgD,GAApD;AAGA5C,UAASiD,CAAAA,aAAcP,CAAAA,SAAUK,CAAAA,SAAjC,GAA6CO,QAAS,CAACV,CAAD,CAAI;AACtD,WAAOA,CAAP;AADsD,GAA1D;AAOA5C,UAASuD,CAAAA,aAAT,GAAyBC,QAASC,sBAAqB,EAAG;GAA1D;AAEAzD,UAASuD,CAAAA,aAAcb,CAAAA,SAAUvB,CAAAA,GAAjC,GAAuCuC,QAAS,CAACd,CAAD,CAAI;AAChD,WAAO,GAAP;AADgD,GAApD;AAGA5C,UAASuD,CAAAA,aAAcb,CAAAA,SAAUG,CAAAA,GAAjC,GAAuCc,QAAS,CAACf,CAAD,CAAI;AAChD,WAAOA,CAAP;AADgD,GAApD;AAGA5C,UAASuD,CAAAA,aAAcb,CAAAA,SAAUK,CAAAA,SAAjC,GAA6Ca,QAAS,CAAChB,CAAD,CAAI;AACtD,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AADsD,GAA1D;AAOA/B,UAAS6D,CAAAA,cAAT,GAA0BC,QAASC,uBAAsB,EAAG;GAA5D;AAEA/D,UAAS6D,CAAAA,cAAenB,CAAAA,SAAUvB,CAAAA,GAAlC,GAAwC6C,QAAS,CAACpB,CAAD,CAAI;AACjD,WAAO,GAAP;AADiD,GAArD;AAGA5C,UAAS6D,CAAAA,cAAenB,CAAAA,SAAUG,CAAAA,GAAlC,GAAwCoB,QAAS,CAACrB,CAAD,CAAI;AACjD,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AADiD,GAArD;AAGA/B,UAAS6D,CAAAA,cAAenB,CAAAA,SAAUK,CAAAA,SAAlC,GAA8CmB,QAAS,CAACtB,CAAD,CAAI;AACvD,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AADuD,GAA3D;AAOA/B,UAASmE,CAAAA,cAAT,GAA0BC,QAASC,uBAAsB,EAAG;GAA5D;AAEArE,UAASmE,CAAAA,cAAezB,CAAAA,SAAUvB,CAAAA,GAAlC,GAAwCmD,QAAS,CAAC1B,CAAD,CAAI;AACjD,WAAO,GAAP;AADiD,GAArD;AAGA5C,UAASmE,CAAAA,cAAezB,CAAAA,SAAUG,CAAAA,GAAlC,GAAwC0B,QAAS,CAAC3B,CAAD,CAAI;AACjD,WAAOA,CAAP;AADiD,GAArD;AAGA5C,UAASmE,CAAAA,cAAezB,CAAAA,SAAUK,CAAAA,SAAlC,GAA8CyB,QAAS,CAAC5B,CAAD,CAAI;AACvD,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AADuD,GAA3D;AAOA/B,UAASyE,CAAAA,YAAT,GAAwBC,QAASC,qBAAoB,EAAG;GAAxD;AAEA3E,UAASyE,CAAAA,YAAa/B,CAAAA,SAAUvB,CAAAA,GAAhC,GAAsCyD,QAAS,CAAChC,CAAD,CAAI;AAC/C,WAAO,OAAP;AAD+C,GAAnD;AAGA5C,UAASyE,CAAAA,YAAa/B,CAAAA,SAAUG,CAAAA,GAAhC,GAAsCgC,QAAS,CAACjC,CAAD,CAAI;AAC/C,WAAOA,CAAP;AAD+C,GAAnD;AAGA5C,UAASyE,CAAAA,YAAa/B,CAAAA,SAAUK,CAAAA,SAAhC,GAA4C+B,QAAS,CAAClC,CAAD,CAAI;AACrD,WAAO,IAAP;AADqD,GAAzD;AAOA5C,UAAS+E,CAAAA,UAAT,GAAsBC,QAASC,mBAAkB,EAAG;GAApD;AAEAjF,UAAS+E,CAAAA,UAAWrC,CAAAA,SAAUvB,CAAAA,GAA9B,GAAoC+D,QAAS,CAACtC,CAAD,CAAI;AAC7C,WAAO,KAAP;AAD6C,GAAjD;AAGA5C,UAAS+E,CAAAA,UAAWrC,CAAAA,SAAUG,CAAAA,GAA9B,GAAoCsC,QAAS,CAACvC,CAAD,CAAI;AAC7C,WAAOA,CAAP;AAD6C,GAAjD;AAGA5C,UAAS+E,CAAAA,UAAWrC,CAAAA,SAAUK,CAAAA,SAA9B,GAA0CqC,QAAS,CAACxC,CAAD,CAAI;AACnD,WAAO,IAAP;AADmD,GAAvD;AAOA5C,UAASqF,CAAAA,kBAAT,GAA8BC,QAASC,2BAA0B,EAAG;GAApE;AAEAvF,UAASqF,CAAAA,kBAAmB3C,CAAAA,SAAUvB,CAAAA,GAAtC,GAA4CqE,QAAS,CAAC5C,CAAD,CAAI;AACrD,WAAO,GAAP;AADqD,GAAzD;AAGA5C,UAASqF,CAAAA,kBAAmB3C,CAAAA,SAAUG,CAAAA,GAAtC,GAA4C4C,QAAS,CAAC7C,CAAD,CAAI;AACrD,WAAOA,CAAE8C,CAAAA,cAAF,EAAP,GAA4B,GAA5B,GAAkC1F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAE+C,CAAAA,WAAF,EAAlB,GAAoC,CAApC,EAAuC,CAAvC,CAAlC,GAA8E,GAA9E,GACI3F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAEgD,CAAAA,UAAF,EAAlB,EAAkC,CAAlC,CADJ,GAC2C,GAD3C,GACiD5F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAEiD,CAAAA,WAAF,EAAlB,EAAmC,CAAnC,CADjD,GACyF,GADzF,GAEI7F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAEkD,CAAAA,aAAF,EAAlB,EAAqC,CAArC,CAFJ,GAE8C,GAF9C,GAEoD9F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAEmD,CAAAA,aAAF,EAAlB,EAAqC,CAArC,CAFpD,GAE8F,GAF9F,GAGI/F,QAAS0B,CAAAA,QAAT,CAAkBkB,CAAEoD,CAAAA,kBAAF,EAAlB,EAA0C,CAA1C,CAHJ,GAGmD,GAHnD;AADqD,GAAzD;AAMAhG,UAASqF,CAAAA,kBAAmB3C,CAAAA,SAAUK,CAAAA,SAAtC,GAAkDkD,QAAS,CAACrD,CAAD,EAAIsD,CAAJ,CAAO;AAC9D,WAAOA,CAAErD,CAAAA,GAAF,CAAMD,CAAN,CAAP;AAD8D,GAAlE;AAOA5C,UAASmG,CAAAA,WAAT,GAAuBC,QAASC,oBAAmB,EAAG;GAAtD;AAEArG,UAASmG,CAAAA,WAAYzD,CAAAA,SAAUvB,CAAAA,GAA/B,GAAqCmF,QAAS,CAAC1D,CAAD,CAAI;AAC9C,WAAO,GAAP;AAD8C,GAAlD;AAGA5C,UAASmG,CAAAA,WAAYzD,CAAAA,SAAUG,CAAAA,GAA/B,GAAqC0D,QAAS,CAAC3D,CAAD,CAAI;AAC9C,WAAOA,CAAE4D,CAAAA,OAAF,EAAP;AAD8C,GAAlD;AAGAxG,UAASmG,CAAAA,WAAYzD,CAAAA,SAAUK,CAAAA,SAA/B,GAA2C0D,QAAS,CAAC7D,CAAD,CAAI;AACpD,WAAOA,CAAE4D,CAAAA,OAAF,EAAYzE,CAAAA,QAAZ,EAAP;AADoD,GAAxD;AAGA/B,UAASmG,CAAAA,WAAYzD,CAAAA,SAAUgE,CAAAA,iBAA/B,GAAmDC,QAAS,CAAC/D,CAAD,CAAI;AAC5D,WAAO,IAAI5C,QAASqF,CAAAA,kBAAb,EAAP;AAD4D,GAAhE;AAOArF,UAAS4G,CAAAA,WAAT,GAAuBC,QAASC,oBAAmB,EAAG;GAAtD;AAEA9G,UAAS4G,CAAAA,WAAYlE,CAAAA,SAAUvB,CAAAA,GAA/B,GAAqC4F,QAAS,CAACnE,CAAD,CAAI;AAC9C,WAAO,GAAP;AAD8C,GAAlD;AAGA5C,UAAS4G,CAAAA,WAAYlE,CAAAA,SAAUG,CAAAA,GAA/B,GAAqCmE,QAAS,CAACpE,CAAD,CAAI;AAC9C,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AAD8C,GAAlD;AAGA/B,UAAS4G,CAAAA,WAAYlE,CAAAA,SAAUK,CAAAA,SAA/B,GAA2CkE,QAAS,CAACrE,CAAD,CAAI;AACpD,WAAOA,CAAEb,CAAAA,QAAF,EAAP;AADoD,GAAxD;AAOA/B,UAASkH,CAAAA,cAAT,GAA0BC,QAASC,uBAAsB,EAAG;GAA5D;AAEApH,UAASkH,CAAAA,cAAexE,CAAAA,SAAUvB,CAAAA,GAAlC,GAAwCkG,QAAS,CAACzE,CAAD,CAAI;AACjD,WAAO,GAAP;AADiD,GAArD;AAGA5C,UAASkH,CAAAA,cAAexE,CAAAA,SAAUG,CAAAA,GAAlC,GAAwCyE,QAAS,CAAC1E,CAAD,CAAI;AACjD,WAAOA,CAAE2E,CAAAA,KAAT;AADiD,GAArD;AAGAvH,UAASkH,CAAAA,cAAexE,CAAAA,SAAUK,CAAAA,SAAlC,GAA8CyE,QAAS,CAAC5E,CAAD,EAAIsD,CAAJ,CAAO;AAC1D,WAAOA,CAAErD,CAAAA,GAAF,CAAMD,CAAN,CAAP;AAD0D,GAA9D;AAOA5C,UAASyH,CAAAA,aAAT,GAAyBC,QAASC,sBAAqB,EAAG;GAA1D;AAEA3H,UAASyH,CAAAA,aAAc/E,CAAAA,SAAUvB,CAAAA,GAAjC,GAAuCyG,QAAS,CAAChF,CAAD,CAAI;AAChD,WAAO,GAAP;AADgD,GAApD;AAGA5C,UAASyH,CAAAA,aAAc/E,CAAAA,SAAUG,CAAAA,GAAjC,GAAuCgF,QAAS,CAACjF,CAAD,CAAI;AAChD,WAAOA,CAAE2E,CAAAA,KAAT;AADgD,GAApD;AAGAvH,UAASyH,CAAAA,aAAc/E,CAAAA,SAAUK,CAAAA,SAAjC,GAA6C+E,QAAS,CAAClF,CAAD,EAAIsD,CAAJ,CAAO;AACzD,WAAOA,CAAErD,CAAAA,GAAF,CAAMD,CAAN,CAAP;AADyD,GAA7D;AAOA5C,UAAS+H,CAAAA,aAAT,GAAyBC,QAASC,sBAAqB,EAAG;GAA1D;AAEAjI,UAAS+H,CAAAA,aAAcrF,CAAAA,SAAUvB,CAAAA,GAAjC,GAAuC+G,QAAS,CAACtF,CAAD,CAAI;AAChD,WAAOA,CAAEzB,CAAAA,GAAT;AADgD,GAApD;AAGAnB,UAAS+H,CAAAA,aAAcrF,CAAAA,SAAUG,CAAAA,GAAjC,GAAuCsF,QAAS,CAACvF,CAAD,CAAI;AAChD,WAAOA,CAAEC,CAAAA,GAAT;AADgD,GAApD;AAGA7C,UAAS+H,CAAAA,aAAcrF,CAAAA,SAAUK,CAAAA,SAAjC,GAA6CqF,QAAS,CAACxF,CAAD,EAAIsD,CAAJ,CAAO;AACzD,WAAO,IAAP;AADyD,GAA7D;AAOAlG,UAASqI,CAAAA,iBAAT,GAA6BC,QAASC,0BAAyB,EAAG;GAAlE;AAEAvI,UAASqI,CAAAA,iBAAkB3F,CAAAA,SAAUvB,CAAAA,GAArC,GAA2CqH,QAAS,CAAC5F,CAAD,CAAI;AACpD,WAAO,KAAP;AADoD,GAAxD;AAGA5C,UAASqI,CAAAA,iBAAkB3F,CAAAA,SAAUG,CAAAA,GAArC,GAA2C4F,QAAS,CAAC7F,CAAD,CAAI;AACpD,QAAI8F,MAAM,EAAV;AACA9F,KAAE+F,CAAAA,OAAF,CAAU,QAAS,CAACC,GAAD,EAAMC,GAAN,CAAW;AAC1BH,SAAII,CAAAA,IAAJ,CAASF,GAAT,CAAA;AAD0B,KAA9B,CAAA;AAGA,WAAOvI,KAAM0I,CAAAA,WAAN,CAAkB,OAAlB,EAA2BL,GAA3B,CAAP;AALoD,GAAxD;AAOA1I,UAASqI,CAAAA,iBAAkB3F,CAAAA,SAAUK,CAAAA,SAArC,GAAiDiG,QAAS,CAACpG,CAAD,EAAIsD,CAAJ,CAAO;AAC7D,WAAO,IAAP;AAD6D,GAAjE;AAOAlG,UAASiJ,CAAAA,sBAAT,GAAkCC,QAASC,wBAAuB,EAAG;GAArE;AAEAnJ,UAASiJ,CAAAA,sBAAuBvG,CAAAA,SAAUvB,CAAAA,GAA1C,GAAgDiI,QAAS,CAACxG,CAAD,CAAI;AACzD,WAAO,KAAP;AADyD,GAA7D;AAGA5C,UAASiJ,CAAAA,sBAAuBvG,CAAAA,SAAUG,CAAAA,GAA1C,GAAgDwG,QAAS,CAACzG,CAAD,CAAI;AACzD,WAAOA,CAAP;AADyD,GAA7D;AAGA5C,UAASiJ,CAAAA,sBAAuBvG,CAAAA,SAAUK,CAAAA,SAA1C,GAAsDuG,QAAS,CAAC1G,CAAD,EAAIsD,CAAJ,CAAO;AAClE,WAAO,IAAP;AADkE,GAAtE;AAOAlG,UAASuJ,CAAAA,iBAAT,GAA6BC,QAASvE,mBAAkB,EAAG;GAA3D;AAEAjF,UAASuJ,CAAAA,iBAAkB7G,CAAAA,SAAUvB,CAAAA,GAArC,GAA2CsI,QAAS,CAAC7G,CAAD,CAAI;AACpD,WAAO,KAAP;AADoD,GAAxD;AAGA5C,UAASuJ,CAAAA,iBAAkB7G,CAAAA,SAAUG,CAAAA,GAArC,GAA2C6G,QAAS,CAAC9G,CAAD,CAAI;AACpD,WAAOA,CAAP;AADoD,GAAxD;AAGA5C,UAASuJ,CAAAA,iBAAkB7G,CAAAA,SAAUK,CAAAA,SAArC,GAAiD4G,QAAS,CAAC/G,CAAD,EAAIsD,CAAJ,CAAO;AAC7D,WAAO,IAAP;AAD6D,GAAjE;AAOAlG,UAAS4J,CAAAA,aAAT,GAAyBC,QAASC,sBAAqB,EAAG;GAA1D;AAEA9J,UAAS4J,CAAAA,aAAclH,CAAAA,SAAUvB,CAAAA,GAAjC,GAAuC4I,QAAS,CAACnH,CAAD,CAAI;AAChD,WAAO,GAAP;AADgD,GAApD;AAGA5C,UAAS4J,CAAAA,aAAclH,CAAAA,SAAUG,CAAAA,GAAjC,GAAuCmH,QAAS,CAACpH,CAAD,CAAI;AAChD,WAAOA,CAAEb,CAAAA,QAAF,CAAW,QAAX,CAAP;AADgD,GAApD;AAGA/B,UAAS4J,CAAAA,aAAclH,CAAAA,SAAUK,CAAAA,SAAjC,GAA6CkH,QAAS,CAACrH,CAAD,EAAIsD,CAAJ,CAAO;AACzD,WAAO,IAAP;AADyD,GAA7D;AAOAlG,UAASkK,CAAAA,iBAAT,GAA6BC,QAASC,0BAAyB,EAAG;GAAlE;AAEApK,UAASkK,CAAAA,iBAAkBxH,CAAAA,SAAUvB,CAAAA,GAArC,GAA2CkJ,QAAS,CAACzH,CAAD,CAAI;AACpD,WAAO,GAAP;AADoD,GAAxD;AAGA5C,UAASkK,CAAAA,iBAAkBxH,CAAAA,SAAUG,CAAAA,GAArC,GAA2CyH,QAAS,CAAC1H,CAAD,CAAI;AACpD,WAAOxC,IAAKmK,CAAAA,aAAL,CAAmB3H,CAAnB,CAAP;AADoD,GAAxD;AAGA5C,UAASkK,CAAAA,iBAAkBxH,CAAAA,SAAUK,CAAAA,SAArC,GAAiDyH,QAAS,CAAC5H,CAAD,EAAIsD,CAAJ,CAAO;AAC7D,WAAO,IAAP;AAD6D,GAAjE;AAIAlG,UAASyK,CAAAA,eAAT,GAA2BC,QAAS,CAACC,EAAD,CAAK;AACrCA,MAAG9B,CAAAA,GAAH,CAAO,IAAP,EAAa,IAAI7I,QAASuC,CAAAA,UAAb,EAAb,CAAA;AACAoI,MAAG9B,CAAAA,GAAH,CAAO/H,MAAP,EAAe,IAAId,QAASiD,CAAAA,aAAb,EAAf,CAAA;AACA0H,MAAG9B,CAAAA,GAAH,CAAO7H,MAAP,EAAe,IAAIhB,QAASuD,CAAAA,aAAb,EAAf,CAAA;AACAoH,MAAG9B,CAAAA,GAAH,CAAOvI,IAAP,EAAa,IAAIN,QAAS6D,CAAAA,cAAb,EAAb,CAAA;AACA8G,MAAG9B,CAAAA,GAAH,CAAO9H,OAAP,EAAgB,IAAIf,QAASmE,CAAAA,cAAb,EAAhB,CAAA;AACAwG,MAAG9B,CAAAA,GAAH,CAAO5H,KAAP,EAAc,IAAIjB,QAASyE,CAAAA,YAAb,EAAd,CAAA;AACAkG,MAAG9B,CAAAA,GAAH,CAAO3H,MAAP,EAAe,IAAIlB,QAAS+E,CAAAA,UAAb,EAAf,CAAA;AACA4F,MAAG9B,CAAAA,GAAH,CAAO+B,IAAP,EAAa,IAAI5K,QAASmG,CAAAA,WAAb,EAAb,CAAA;AACAwE,MAAG9B,CAAAA,GAAH,CAAOxI,KAAMwK,CAAAA,IAAb,EAAmB,IAAI7K,QAAS4G,CAAAA,WAAb,EAAnB,CAAA;AACA+D,MAAG9B,CAAAA,GAAH,CAAOxI,KAAMyK,CAAAA,OAAb,EAAsB,IAAI9K,QAASkH,CAAAA,cAAb,EAAtB,CAAA;AACAyD,MAAG9B,CAAAA,GAAH,CAAOxI,KAAM0K,CAAAA,MAAb,EAAqB,IAAI/K,QAASyH,CAAAA,aAAb,EAArB,CAAA;AACAkD,MAAG9B,CAAAA,GAAH,CAAOxI,KAAM2K,CAAAA,WAAb,EAA0B,IAAIhL,QAAS+H,CAAAA,aAAb,EAA1B,CAAA;AACA4C,MAAG9B,CAAAA,GAAH,CAAOxI,KAAM4K,CAAAA,UAAb,EAAyB,IAAIjL,QAASqI,CAAAA,iBAAb,EAAzB,CAAA;AACAsC,MAAG9B,CAAAA,GAAH,CAAOxI,KAAM6K,CAAAA,eAAb,EAA8B,IAAIlL,QAASiJ,CAAAA,sBAAb,EAA9B,CAAA;AACA0B,MAAG9B,CAAAA,GAAH,CAAOxI,KAAM8K,CAAAA,UAAb,EAAyB,IAAInL,QAASuJ,CAAAA,iBAAb,EAAzB,CAAA;AAEA,QAAI,MAAO3J,KAAKwL,CAAAA,MAAOC,CAAAA,MAAvB,IAAiC,WAAjC;AACIV,QAAG9B,CAAAA,GAAH,CAAOjJ,IAAKwL,CAAAA,MAAOC,CAAAA,MAAnB,EAA2B,IAAIrL,QAAS4J,CAAAA,aAAb,EAA3B,CAAA;AADJ;AAIA,QAAI,MAAO0B,WAAX,IAAyB,WAAzB;AACIX,QAAG9B,CAAAA,GAAH,CAAOyC,UAAP,EAAmB,IAAItL,QAASkK,CAAAA,iBAAb,EAAnB,CAAA;AADJ;AAIA,WAAOS,EAAP;AAzBqC,GAAzC;AA+BA3K,UAASuL,CAAAA,QAAT,GAAoBC,QAASC,iBAAgB,EAAG;AAC5C,QAAKzL,CAAAA,QAAL,GAAgB,EAAhB;AACAA,YAASyK,CAAAA,eAAT,CAAyB,IAAzB,CAAA;AAF4C,GAAhD;AAKAzK,UAASuL,CAAAA,QAAS7I,CAAAA,SAAUgJ,CAAAA,GAA5B,GAAkCC,QAAS,CAAC9K,IAAD,CAAO;AAC9C,QAAIqF,IAAI,IAAR;AACA,QAAI,MAAOrF,KAAX,KAAoB,QAApB;AACIqF,OAAA,GAAI,IAAKlG,CAAAA,QAAL,CAAca,IAAd,CAAJ;AADJ;AAGIqF,OAAA,GAAI,IAAKlG,CAAAA,QAAL,CAAcA,QAASW,CAAAA,OAAT,CAAiBE,IAAjB,CAAd,CAAJ;AAHJ;AAKA,QAAIqF,CAAJ,IAAS,IAAT;AACI,aAAOA,CAAP;AADJ;AAGI,aAAO,IAAKlG,CAAAA,QAAL,CAAc,SAAd,CAAP;AAHJ;AAP8C,GAAlD;AAaAA,UAASuL,CAAAA,QAAS7I,CAAAA,SAAlB,CAA4B,KAA5B,CAAA,GAAqC1C,QAASuL,CAAAA,QAAS7I,CAAAA,SAAUgJ,CAAAA,GAAjE;AAEA1L,UAAS4L,CAAAA,QAAT,GAAoBC,QAAS,CAAC1K,GAAD,CAAM;AAC/B,WAAQA,GAAR;AACI,WAAK,MAAL;AACA,WAAK,QAAL;AACA,WAAK,SAAL;AACA,WAAK,QAAL;AACA,WAAK,OAAL;AACA,WAAK,KAAL;AACI,eAAO,KAAP;AACA;AARR;AAUA,WAAO,IAAP;AAX+B,GAAnC;AAcAnB,UAASuL,CAAAA,QAAS7I,CAAAA,SAAUmG,CAAAA,GAA5B,GAAkCiD,QAAS,CAACjL,IAAD,EAAOkL,OAAP,CAAgB;AACvD,QAAI,MAAOlL,KAAX,KAAoB,QAApB,IAAgCb,QAAS4L,CAAAA,QAAT,CAAkB/K,IAAlB,CAAhC;AACI,UAAKb,CAAAA,QAAL,CAAca,IAAd,CAAA,GAAsBkL,OAAtB;AADJ;AAGI,UAAK/L,CAAAA,QAAL,CAAcA,QAASW,CAAAA,OAAT,CAAiBE,IAAjB,CAAd,CAAA,GAAwCkL,OAAxC;AAHJ;AADuD,GAA3D;AAhamB,CAAvB,CAAA;;\",\n\"sources\":[\"com/cognitect/transit/handlers.js\"],\n\"sourcesContent\":[\"// Copyright 2014 Cognitect. All Rights Reserved.\\n//\\n// Licensed under the Apache License, Version 2.0 (the \\\"License\\\");\\n// you may not use this file except in compliance with the License.\\n// You may obtain a copy of the License at\\n//\\n//      http://www.apache.org/licenses/LICENSE-2.0\\n//\\n// Unless required by applicable law or agreed to in writing, software\\n// distributed under the License is distributed on an \\\"AS-IS\\\" BASIS,\\n// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\\n// See the License for the specific language governing permissions and\\n// limitations under the License.\\n\\ngoog.provide(\\\"com.cognitect.transit.handlers\\\");\\ngoog.require(\\\"com.cognitect.transit.util\\\");\\ngoog.require(\\\"com.cognitect.transit.types\\\");\\ngoog.require(\\\"goog.math.Long\\\");\\n\\ngoog.scope(function () {\\n\\n    var handlers = com.cognitect.transit.handlers,\\n        util     = com.cognitect.transit.util,\\n        types    = com.cognitect.transit.types,\\n        Long     = goog.math.Long;\\n\\n    handlers.ctorGuid = 0;\\n\\n    /**\\n     * @const\\n     * @type {string}\\n     */\\n    handlers.ctorGuidProperty = \\\"transit$guid$\\\" + util.randomUUID();\\n\\n    handlers.typeTag = function (ctor) {\\n        if (ctor == null) {\\n            return \\\"null\\\";\\n        } else if (ctor === String) {\\n            return \\\"string\\\";\\n        } else if (ctor === Boolean) {\\n            return \\\"boolean\\\";\\n        } else if (ctor === Number) {\\n            return \\\"number\\\";\\n        } else if (ctor === Array) {\\n            return \\\"array\\\";\\n        } else if (ctor === Object) {\\n            return \\\"map\\\";\\n        } else {\\n            var tag = ctor[handlers.ctorGuidProperty];\\n            if (tag == null) {\\n                if (typeof Object.defineProperty != \\\"undefined\\\") {\\n                    tag = ++handlers.ctorGuid;\\n                    Object.defineProperty(ctor, handlers.ctorGuidProperty, {\\n                        value: tag,\\n                        enumerable: false\\n                    });\\n                } else {\\n                    ctor[handlers.ctorGuidProperty] = tag = ++handlers.ctorGuid;\\n                }\\n            }\\n            return tag;\\n        }\\n    };\\n\\n    handlers.constructor = function (x) {\\n        if (x == null) {\\n            return null;\\n        } else {\\n            return x.constructor;\\n        }\\n    };\\n\\n    handlers.padZeros = function (n, m) {\\n        var s = n.toString();\\n        for (var i = s.length; i < m; i++) {\\n            s = \\\"0\\\" + s;\\n        }\\n        return s;\\n    };\\n\\n    handlers.stringableKeys = function (m) {\\n        var stringable = false,\\n            ks = util.objectKeys(m);\\n\\n        for (var i = 0; i < ks.length; i++) {\\n        }\\n\\n        return true;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.NilHandler = function Transit$NilHandler() {\\n    };\\n    handlers.NilHandler.prototype.tag = function (v) {\\n        return \\\"_\\\";\\n    };\\n    handlers.NilHandler.prototype.rep = function (v) {\\n        return null;\\n    };\\n    handlers.NilHandler.prototype.stringRep = function (v) {\\n        return \\\"null\\\";\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.StringHandler = function Transit$StringHandler() {\\n    };\\n    handlers.StringHandler.prototype.tag = function (v) {\\n        return \\\"s\\\";\\n    };\\n    handlers.StringHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.StringHandler.prototype.stringRep = function (v) {\\n        return v;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.NumberHandler = function Transit$NumberHandler() {\\n    };\\n    handlers.NumberHandler.prototype.tag = function (v) {\\n        return \\\"i\\\";\\n    };\\n    handlers.NumberHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.NumberHandler.prototype.stringRep = function (v) {\\n        return v.toString();\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.IntegerHandler = function Transit$IntegerHandler() {\\n    };\\n    handlers.IntegerHandler.prototype.tag = function (v) {\\n        return \\\"i\\\";\\n    };\\n    handlers.IntegerHandler.prototype.rep = function (v) {\\n        return v.toString();\\n    };\\n    handlers.IntegerHandler.prototype.stringRep = function (v) {\\n        return v.toString();\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.BooleanHandler = function Transit$BooleanHandler() {\\n    };\\n    handlers.BooleanHandler.prototype.tag = function (v) {\\n        return \\\"?\\\";\\n    };\\n    handlers.BooleanHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.BooleanHandler.prototype.stringRep = function (v) {\\n        return v.toString();\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.ArrayHandler = function Transit$ArrayHandler() {\\n    };\\n    handlers.ArrayHandler.prototype.tag = function (v) {\\n        return \\\"array\\\";\\n    };\\n    handlers.ArrayHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.ArrayHandler.prototype.stringRep = function (v) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.MapHandler = function Transit$MapHandler() {\\n    };\\n    handlers.MapHandler.prototype.tag = function (v) {\\n        return \\\"map\\\";\\n    };\\n    handlers.MapHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.MapHandler.prototype.stringRep = function (v) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.VerboseDateHandler = function Transit$VerboseDateHandler() {\\n    };\\n    handlers.VerboseDateHandler.prototype.tag = function (v) {\\n        return \\\"t\\\";\\n    };\\n    handlers.VerboseDateHandler.prototype.rep = function (v) {\\n        return v.getUTCFullYear() + \\\"-\\\" + handlers.padZeros(v.getUTCMonth() + 1, 2) + \\\"-\\\" +\\n            handlers.padZeros(v.getUTCDate(), 2) + \\\"T\\\" + handlers.padZeros(v.getUTCHours(), 2) + \\\":\\\" +\\n            handlers.padZeros(v.getUTCMinutes(), 2) + \\\":\\\" + handlers.padZeros(v.getUTCSeconds(), 2) + \\\".\\\" +\\n            handlers.padZeros(v.getUTCMilliseconds(), 3) + \\\"Z\\\";\\n    };\\n    handlers.VerboseDateHandler.prototype.stringRep = function (v, h) {\\n        return h.rep(v);\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.DateHandler = function Transit$DateHandler() {\\n    };\\n    handlers.DateHandler.prototype.tag = function (v) {\\n        return \\\"m\\\";\\n    };\\n    handlers.DateHandler.prototype.rep = function (v) {\\n        return v.valueOf();\\n    };\\n    handlers.DateHandler.prototype.stringRep = function (v) {\\n        return v.valueOf().toString();\\n    };\\n    handlers.DateHandler.prototype.getVerboseHandler = function (v) {\\n        return new handlers.VerboseDateHandler();\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.UUIDHandler = function Transit$UUIDHandler() {\\n    };\\n    handlers.UUIDHandler.prototype.tag = function (v) {\\n        return \\\"u\\\";\\n    };\\n    handlers.UUIDHandler.prototype.rep = function (v) {\\n        return v.toString();\\n    };\\n    handlers.UUIDHandler.prototype.stringRep = function (v) {\\n        return v.toString();\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.KeywordHandler = function Transit$KeywordHandler() {\\n    };\\n    handlers.KeywordHandler.prototype.tag = function (v) {\\n        return \\\":\\\";\\n    };\\n    handlers.KeywordHandler.prototype.rep = function (v) {\\n        return v._name;\\n    }; // NOTE: should be fqn\\n    handlers.KeywordHandler.prototype.stringRep = function (v, h) {\\n        return h.rep(v);\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.SymbolHandler = function Transit$SymbolHandler() {\\n    };\\n    handlers.SymbolHandler.prototype.tag = function (v) {\\n        return \\\"$\\\";\\n    };\\n    handlers.SymbolHandler.prototype.rep = function (v) {\\n        return v._name;\\n    }; // NOTE: should be str\\n    handlers.SymbolHandler.prototype.stringRep = function (v, h) {\\n        return h.rep(v);\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.TaggedHandler = function Transit$TaggedHandler() {\\n    };\\n    handlers.TaggedHandler.prototype.tag = function (v) {\\n        return v.tag;\\n    };\\n    handlers.TaggedHandler.prototype.rep = function (v) {\\n        return v.rep;\\n    };\\n    handlers.TaggedHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.TransitSetHandler = function Transit$TransitSetHandler() {\\n    };\\n    handlers.TransitSetHandler.prototype.tag = function (v) {\\n        return \\\"set\\\";\\n    };\\n    handlers.TransitSetHandler.prototype.rep = function (v) {\\n        var arr = [];\\n        v.forEach(function (key, set) {\\n            arr.push(key);\\n        });\\n        return types.taggedValue(\\\"array\\\", arr);\\n    };\\n    handlers.TransitSetHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.TransitArrayMapHandler = function Transit$ArrayMapHandler() {\\n    };\\n    handlers.TransitArrayMapHandler.prototype.tag = function (v) {\\n        return \\\"map\\\";\\n    };\\n    handlers.TransitArrayMapHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.TransitArrayMapHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.TransitMapHandler = function Transit$MapHandler() {\\n    };\\n    handlers.TransitMapHandler.prototype.tag = function (v) {\\n        return \\\"map\\\";\\n    };\\n    handlers.TransitMapHandler.prototype.rep = function (v) {\\n        return v;\\n    };\\n    handlers.TransitMapHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.BufferHandler = function Transit$BufferHandler() {\\n    };\\n    handlers.BufferHandler.prototype.tag = function (v) {\\n        return \\\"b\\\";\\n    };\\n    handlers.BufferHandler.prototype.rep = function (v) {\\n        return v.toString(\\\"base64\\\");\\n    };\\n    handlers.BufferHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.Uint8ArrayHandler = function Transit$Uint8ArrayHandler() {\\n    };\\n    handlers.Uint8ArrayHandler.prototype.tag = function (v) {\\n        return \\\"b\\\";\\n    };\\n    handlers.Uint8ArrayHandler.prototype.rep = function (v) {\\n        return util.Uint8ToBase64(v);\\n    };\\n    handlers.Uint8ArrayHandler.prototype.stringRep = function (v, h) {\\n        return null;\\n    };\\n\\n    handlers.defaultHandlers = function (hs) {\\n        hs.set(null, new handlers.NilHandler());\\n        hs.set(String, new handlers.StringHandler());\\n        hs.set(Number, new handlers.NumberHandler());\\n        hs.set(Long, new handlers.IntegerHandler());\\n        hs.set(Boolean, new handlers.BooleanHandler());\\n        hs.set(Array, new handlers.ArrayHandler());\\n        hs.set(Object, new handlers.MapHandler());\\n        hs.set(Date, new handlers.DateHandler());\\n        hs.set(types.UUID, new handlers.UUIDHandler());\\n        hs.set(types.Keyword, new handlers.KeywordHandler());\\n        hs.set(types.Symbol, new handlers.SymbolHandler());\\n        hs.set(types.TaggedValue, new handlers.TaggedHandler());\\n        hs.set(types.TransitSet, new handlers.TransitSetHandler());\\n        hs.set(types.TransitArrayMap, new handlers.TransitArrayMapHandler());\\n        hs.set(types.TransitMap, new handlers.TransitMapHandler());\\n\\n        if (typeof goog.global.Buffer != \\\"undefined\\\") {\\n            hs.set(goog.global.Buffer, new handlers.BufferHandler());\\n        }\\n\\n        if (typeof Uint8Array != \\\"undefined\\\") {\\n            hs.set(Uint8Array, new handlers.Uint8ArrayHandler());\\n        }\\n\\n        return hs;\\n    };\\n\\n    /**\\n     * @constructor\\n     */\\n    handlers.Handlers = function Transit$Handlers() {\\n        this.handlers = {};\\n        handlers.defaultHandlers(this);\\n    };\\n\\n    handlers.Handlers.prototype.get = function (ctor) {\\n        var h = null;\\n        if (typeof ctor === \\\"string\\\") {\\n            h = this.handlers[ctor];\\n        } else {\\n            h = this.handlers[handlers.typeTag(ctor)];\\n        }\\n        if (h != null) {\\n            return h;\\n        } else {\\n            return this.handlers[\\\"default\\\"];\\n        }\\n    };\\n    handlers.Handlers.prototype[\\\"get\\\"] = handlers.Handlers.prototype.get;\\n\\n    handlers.validTag = function (tag) {\\n        switch (tag) {\\n            case \\\"null\\\":\\n            case \\\"string\\\":\\n            case \\\"boolean\\\":\\n            case \\\"number\\\":\\n            case \\\"array\\\":\\n            case \\\"map\\\":\\n                return false;\\n                break;\\n        }\\n        return true;\\n    };\\n\\n    handlers.Handlers.prototype.set = function (ctor, handler) {\\n        if (typeof ctor === \\\"string\\\" && handlers.validTag(ctor)) {\\n            this.handlers[ctor] = handler;\\n        } else {\\n            this.handlers[handlers.typeTag(ctor)] = handler;\\n        }\\n    };\\n\\n});    \\n\"],\n\"names\":[\"goog\",\"provide\",\"require\",\"scope\",\"handlers\",\"com\",\"cognitect\",\"transit\",\"util\",\"types\",\"Long\",\"math\",\"ctorGuid\",\"ctorGuidProperty\",\"randomUUID\",\"typeTag\",\"handlers.typeTag\",\"ctor\",\"String\",\"Boolean\",\"Number\",\"Array\",\"Object\",\"tag\",\"defineProperty\",\"value\",\"enumerable\",\"constructor\",\"handlers.constructor\",\"x\",\"padZeros\",\"handlers.padZeros\",\"n\",\"m\",\"s\",\"toString\",\"i\",\"length\",\"stringableKeys\",\"handlers.stringableKeys\",\"stringable\",\"ks\",\"objectKeys\",\"NilHandler\",\"handlers.NilHandler\",\"Transit$NilHandler\",\"prototype\",\"handlers.NilHandler.prototype.tag\",\"v\",\"rep\",\"handlers.NilHandler.prototype.rep\",\"stringRep\",\"handlers.NilHandler.prototype.stringRep\",\"StringHandler\",\"handlers.StringHandler\",\"Transit$StringHandler\",\"handlers.StringHandler.prototype.tag\",\"handlers.StringHandler.prototype.rep\",\"handlers.StringHandler.prototype.stringRep\",\"NumberHandler\",\"handlers.NumberHandler\",\"Transit$NumberHandler\",\"handlers.NumberHandler.prototype.tag\",\"handlers.NumberHandler.prototype.rep\",\"handlers.NumberHandler.prototype.stringRep\",\"IntegerHandler\",\"handlers.IntegerHandler\",\"Transit$IntegerHandler\",\"handlers.IntegerHandler.prototype.tag\",\"handlers.IntegerHandler.prototype.rep\",\"handlers.IntegerHandler.prototype.stringRep\",\"BooleanHandler\",\"handlers.BooleanHandler\",\"Transit$BooleanHandler\",\"handlers.BooleanHandler.prototype.tag\",\"handlers.BooleanHandler.prototype.rep\",\"handlers.BooleanHandler.prototype.stringRep\",\"ArrayHandler\",\"handlers.ArrayHandler\",\"Transit$ArrayHandler\",\"handlers.ArrayHandler.prototype.tag\",\"handlers.ArrayHandler.prototype.rep\",\"handlers.ArrayHandler.prototype.stringRep\",\"MapHandler\",\"handlers.MapHandler\",\"Transit$MapHandler\",\"handlers.MapHandler.prototype.tag\",\"handlers.MapHandler.prototype.rep\",\"handlers.MapHandler.prototype.stringRep\",\"VerboseDateHandler\",\"handlers.VerboseDateHandler\",\"Transit$VerboseDateHandler\",\"handlers.VerboseDateHandler.prototype.tag\",\"handlers.VerboseDateHandler.prototype.rep\",\"getUTCFullYear\",\"getUTCMonth\",\"getUTCDate\",\"getUTCHours\",\"getUTCMinutes\",\"getUTCSeconds\",\"getUTCMilliseconds\",\"handlers.VerboseDateHandler.prototype.stringRep\",\"h\",\"DateHandler\",\"handlers.DateHandler\",\"Transit$DateHandler\",\"handlers.DateHandler.prototype.tag\",\"handlers.DateHandler.prototype.rep\",\"valueOf\",\"handlers.DateHandler.prototype.stringRep\",\"getVerboseHandler\",\"handlers.DateHandler.prototype.getVerboseHandler\",\"UUIDHandler\",\"handlers.UUIDHandler\",\"Transit$UUIDHandler\",\"handlers.UUIDHandler.prototype.tag\",\"handlers.UUIDHandler.prototype.rep\",\"handlers.UUIDHandler.prototype.stringRep\",\"KeywordHandler\",\"handlers.KeywordHandler\",\"Transit$KeywordHandler\",\"handlers.KeywordHandler.prototype.tag\",\"handlers.KeywordHandler.prototype.rep\",\"_name\",\"handlers.KeywordHandler.prototype.stringRep\",\"SymbolHandler\",\"handlers.SymbolHandler\",\"Transit$SymbolHandler\",\"handlers.SymbolHandler.prototype.tag\",\"handlers.SymbolHandler.prototype.rep\",\"handlers.SymbolHandler.prototype.stringRep\",\"TaggedHandler\",\"handlers.TaggedHandler\",\"Transit$TaggedHandler\",\"handlers.TaggedHandler.prototype.tag\",\"handlers.TaggedHandler.prototype.rep\",\"handlers.TaggedHandler.prototype.stringRep\",\"TransitSetHandler\",\"handlers.TransitSetHandler\",\"Transit$TransitSetHandler\",\"handlers.TransitSetHandler.prototype.tag\",\"handlers.TransitSetHandler.prototype.rep\",\"arr\",\"forEach\",\"key\",\"set\",\"push\",\"taggedValue\",\"handlers.TransitSetHandler.prototype.stringRep\",\"TransitArrayMapHandler\",\"handlers.TransitArrayMapHandler\",\"Transit$ArrayMapHandler\",\"handlers.TransitArrayMapHandler.prototype.tag\",\"handlers.TransitArrayMapHandler.prototype.rep\",\"handlers.TransitArrayMapHandler.prototype.stringRep\",\"TransitMapHandler\",\"handlers.TransitMapHandler\",\"handlers.TransitMapHandler.prototype.tag\",\"handlers.TransitMapHandler.prototype.rep\",\"handlers.TransitMapHandler.prototype.stringRep\",\"BufferHandler\",\"handlers.BufferHandler\",\"Transit$BufferHandler\",\"handlers.BufferHandler.prototype.tag\",\"handlers.BufferHandler.prototype.rep\",\"handlers.BufferHandler.prototype.stringRep\",\"Uint8ArrayHandler\",\"handlers.Uint8ArrayHandler\",\"Transit$Uint8ArrayHandler\",\"handlers.Uint8ArrayHandler.prototype.tag\",\"handlers.Uint8ArrayHandler.prototype.rep\",\"Uint8ToBase64\",\"handlers.Uint8ArrayHandler.prototype.stringRep\",\"defaultHandlers\",\"handlers.defaultHandlers\",\"hs\",\"Date\",\"UUID\",\"Keyword\",\"Symbol\",\"TaggedValue\",\"TransitSet\",\"TransitArrayMap\",\"TransitMap\",\"global\",\"Buffer\",\"Uint8Array\",\"Handlers\",\"handlers.Handlers\",\"Transit$Handlers\",\"get\",\"handlers.Handlers.prototype.get\",\"validTag\",\"handlers.validTag\",\"handlers.Handlers.prototype.set\",\"handler\"]\n}\n"]